/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 * Program WebSite: http://methane.sourceforge.net/index.html              *
 * Project Email: rombust@postmaster.co.uk                                 *
 *                                                                         *
 ***************************************************************************/

//------------------------------------------------------------------------------
// The SYMBIAN main document file based on GP2x
//------------------------------------------------------------------------------

#include <stdlib.h>
#include "font32.h"
#include "SDL.h"
#include "SDL_framerate.h"
#include "doc.h"

#ifdef METHANE_MIKMOD
#include "../mikmod/audiodrv.h"
#endif
int VOL;
int option_page = 0;
int game_paused = 0;
int key_redefine_index = 0;
int on_options_screen = 1;
const char* KGameKeys[] = {" LEFT", "RIGHT", "   UP", " DOWN", " FIRE", "PAUSE", " SWAP"};
SDLKey m_GameControls[7] = {SDLK_LEFT, SDLK_RIGHT, SDLK_UP, SDLK_DOWN, SDLK_SPACE, SDLK_p, SDLK_RETURN};
//------------------------------------------------------------------------------
// Private Functions
//------------------------------------------------------------------------------
extern void main_code(void);

//------------------------------------------------------------------------------
// The Game Instance
//------------------------------------------------------------------------------
CMethDoc* Game = NULL;
FPSmanager FpsManager;
SDL_Surface * SdlScreen = 0;


static char TheScreen[SCR_WIDTH * SCR_HEIGHT];
static int SampleChannel = 5;	// Used by CMethDoc::PlaySample

//------------------------------------------------------------------------------
// The HighScore table filename
//------------------------------------------------------------------------------
#ifdef UIQ3
static char HighScoreFileName[] = "c:\\shared\\methanebros\\Methane.HiScores";
#else
static char HighScoreFileName[] = "c:\\data\\methanebros\\Methane.HiScores";
#endif

#define HighScoreLoadBufferSize (MAX_HISCORES * 64)


//------------------------------------------------------------------------------
// The Main Function
//------------------------------------------------------------------------------
int main (int argc, char *argv[])
{
	// init	
	if (SDL_Init(SDL_INIT_JOYSTICK|SDL_INIT_VIDEO|SDL_INIT_AUDIO) < 0) {
		fprintf (stderr, "Can't init SDL : %s", SDL_GetError());
		return 1;
	}
	atexit (SDL_Quit);
	SDL_JoystickOpen (0);	
    SDL_EnableKeyRepeat (
		SDL_DEFAULT_REPEAT_DELAY, SDL_DEFAULT_REPEAT_INTERVAL);    
	// run
    Game = new CMethDoc;
	main_code();					// The main routine
	delete Game;

	return (0) ;
}

//------------------------------------------------------------------------------
//! \brief The program main code
//------------------------------------------------------------------------------
//SDL_Surface *hwscreen;
void main_code(void)
{
VOL=64;
	JOYSTICK *jptr1;
//	JOYSTICK *jptr2;

	
                 //SdlScreen = SDL_CreateRGBSurface(SDL_SWSURFACE, GP2X_SCREEN_W, GP2X_SCREEN_H, 8, 0, 0, 0, 0);
                 /*hwscreen*/SdlScreen = SDL_SetVideoMode(GP2X_SCREEN_W, GP2X_SCREEN_H, 8, SDL_SWSURFACE);


	if (!/*hwscreen*/SdlScreen)
	{
		fprintf (stderr, "Couldn't set video mode : %s\n", SDL_GetError());
		return;
	}


	SDL_ShowCursor (SDL_DISABLE);

	printf("The GNU General Public License V2 applies to this game.\n\n");
	printf("See: http://methane.sourceforge.net\n");
	printf("Instructions:\n\n");
	printf("Press FIRE to start game .\n");
	printf("Press FIRE to fire gas from the gun.\n");
	printf("Press UP to jump.\n");
	printf("Hold FIRE to suck a trapped baddie into the gun.\n");
	printf("Release FIRE to throw the trapped baddie from the gun.\n");
	printf("Throw baddies at the wall to destroy them.\n\n");
	printf("ESCAPE = Quit\n");
	printf("RETURN = Change player graphic during game (and save high scores)\n");
	//printf("F1 = Next Level (DISABLED)\n");


	Game->InitSoundDriver();
	Game->InitGame ();
	Game->LoadScores();
	Game->StartGame();
	jptr1 = &Game->m_GameTarget.m_Joy1;
	
//	jptr2 = &Game.m_GameTarget.m_Joy2;

	SDL_initFramerate (&FpsManager);

	SDL_PauseAudio(0);
	int run = 1;
	int tempo = 0; //tempo pour le bouton Start, pour pas que le skin du perso change trop vite
	while(run)
	{
		if (tempo>0) tempo--; // ca permet de faire 10 passages de buolce avant de rechanger si tu laisses Start appuyé
		//SDL_PumpEvents();
		jptr1->key = 0;
		SDL_Event event;
		if(SDL_PollEvent(&event))
			{
			if(event.type == SDL_KEYDOWN)
				{
				jptr1->key =(int) event.key.keysym.sym;
				}
			}
		
		Uint8 * key = SDL_GetKeyState (NULL);
		if (key[SDLK_ESCAPE]) break; // ESCAPE = Exit

		//		jptr1->key = key;
		//		jptr2->key = key;

		jptr1->right  = (key[SDLK_RIGHT] > 0)|(key[m_GameControls[1]] > 0);
		jptr1->left  = (key[SDLK_LEFT] > 0)|(key[m_GameControls[0]] > 0);

		if (key[SDLK_UP] | key[m_GameControls[2]])
			{
			jptr1->up = 1;		
			}
		else
			{
			jptr1->up = 0;
			}

		jptr1->down  = (key[SDLK_DOWN] > 0)|(key[m_GameControls[3]]);
			

		if (game_paused)	// On pause
			{
			// Any key to continue
			if (jptr1->key)	// Ignore mouse buttons
				{
				game_paused = 0;
				}
			}
		else
			{
			if (!on_options_screen)
				{
				if (key[m_GameControls[5]]) game_paused = 1;
				}
			}
		
		if((jptr1->down || jptr1->up || jptr1->left || jptr1->right) && !on_options_screen)
			{
			jptr1->key = 0;
			}
		
		jptr1->fire  = (key[SDLK_LCTRL] > 0)|(key[m_GameControls[4]]>0)|(key[SDLK_F5]>0);
		
		if(jptr1->fire)
			{
			jptr1->key = 13;
			}		
		
		if(on_options_screen)
			{
			if(jptr1->key != 0 && !tempo)
				{
				tempo = 10;
				if(option_page < 3)
					{
					option_page++;
					if(option_page == 3 && jptr1->fire)
						{
						key_redefine_index = 7;
						}
					}
				else
					{
					m_GameControls[key_redefine_index] =(SDLKey) jptr1->key;
					key_redefine_index++;
					}

				if (option_page==3 && key_redefine_index == 7)
					{
					on_options_screen = 0;	// Start the game
					jptr1->fire = 0;
					SDL_Delay(200);
					}	
				}

			}
		else
			{
			if ((key[m_GameControls[6]])&(tempo==0)) //Start , apres, y a rien de compliqué
				{
				tempo=10;				
				Game->m_GameTarget.m_Game.TogglePuffBlow();
				}
			}

		// (CHEAT MODE DISABLED) --> jptr1->next_level = 0;
		if (on_options_screen)
			{
			Game->DisplayOptions(TheScreen, option_page);			
			}
		else
			{
			Game->MainLoop (0);
			}
		SDL_framerateDelay (&FpsManager);
	}
	Game->SaveScores ();

	SDL_FreeSurface (SdlScreen);
	//SDL_FreeSurface (hwscreen);
}
void rafraichir_ecran(void)
 {
//SDL_BlitSurface(SdlScreen, NULL, hwscreen, NULL);
 SDL_UpdateRect(SdlScreen, 0, 0, GP2X_SCREEN_W, GP2X_SCREEN_H);
 }
//------------------------------------------------------------------------------
//! \brief Initialise Document
//------------------------------------------------------------------------------
CMethDoc::CMethDoc()
{	
#ifdef METHANE_MIKMOD
	SMB_NEW(m_pMikModDrv,CMikModDrv);
#endif
	m_GameTarget.Init(this);
}

//------------------------------------------------------------------------------
//! \brief Destroy Document
//------------------------------------------------------------------------------
CMethDoc::~CMethDoc()
{
#ifdef METHANE_MIKMOD
	if (m_pMikModDrv)
	{
		delete(m_pMikModDrv);
		m_pMikModDrv = 0;
	}
#endif
}

//------------------------------------------------------------------------------
//! \brief Initialise the game
//------------------------------------------------------------------------------
void CMethDoc::InitGame(void)
{
	m_GameTarget.InitGame (TheScreen);
	m_GameTarget.PrepareSoundDriver ();
}

//------------------------------------------------------------------------------
//! \brief Initialise the sound driver
//------------------------------------------------------------------------------
void CMethDoc::InitSoundDriver(void)
{
#ifdef METHANE_MIKMOD
	m_pMikModDrv->InitDriver();
#endif
}

//------------------------------------------------------------------------------
//! \brief Remove the sound driver
//------------------------------------------------------------------------------
void CMethDoc::RemoveSoundDriver(void)
{
#ifdef METHANE_MIKMOD
	m_pMikModDrv->RemoveDriver();
#endif
}

//------------------------------------------------------------------------------
//! \brief Start the game
//------------------------------------------------------------------------------
void CMethDoc::StartGame(void)
{
	m_GameTarget.StartGame();
}

//------------------------------------------------------------------------------
//! \brief Redraw the game main view
//!
//! 	\param pal_change_flag : 0 = Palette not changed
//------------------------------------------------------------------------------
void CMethDoc::RedrawMainView( int pal_change_flag )
{
	// Function not used
}

//------------------------------------------------------------------------------
//! \brief Draw the screen
//!
//! 	\param screen_ptr = UNUSED
//------------------------------------------------------------------------------
void CMethDoc::DrawScreen( void *screen_ptr )
{
	METHANE_RGB *pptr;
	int cnt;
    SDL_Color colors [PALETTE_SIZE];

    if (SDL_MUSTLOCK (SdlScreen))
	{
		SDL_LockSurface (SdlScreen);
	}

	// Set the game palette
	pptr = m_GameTarget.m_rgbPalette;
	if(!game_paused)
		{
			for (cnt=0; cnt < PALETTE_SIZE; cnt++, pptr++)
			{
				colors[cnt].r = pptr->red;
				colors[cnt].g = pptr->green;
				colors[cnt].b = pptr->blue;
			}
		}
	else
		{
		for (cnt=0; cnt < PALETTE_SIZE; cnt++, pptr++)
			{
			colors[cnt].r = pptr->red;
			colors[cnt].g = pptr->red;
			colors[cnt].b = pptr->red;
			}
		}
	SDL_SetPalette (SdlScreen, SDL_LOGPAL|SDL_PHYSPAL, colors, 0, PALETTE_SIZE);

	// Copy the pixels
	char * dptr = (char *) SdlScreen->pixels;
	char * sptr = TheScreen + 4 * GP2X_SCREEN_W;
	for (int y = 0; y < GP2X_SCREEN_H; y++) {
		for (int x = 0; x < GP2X_SCREEN_W; x++) {
			*dptr++ = *sptr++;
		}
		dptr += (SdlScreen->pitch - GP2X_SCREEN_W);
	}

    if (SDL_MUSTLOCK (SdlScreen))
	{
		SDL_UnlockSurface (SdlScreen);
	}

	// Show the new screen
	rafraichir_ecran();
}

//------------------------------------------------------------------------------
//! \brief The Game Main Loop
//!
//! 	\param screen_ptr = UNUSED
//------------------------------------------------------------------------------
void CMethDoc::MainLoop( void *screen_ptr )
{
	if (!game_paused)
		{
		m_GameTarget.MainLoop();
		}
	
	DrawScreen( screen_ptr );
}

//------------------------------------------------------------------------------
//! \brief Play a sample (called from the game)
//!
//! 	\param id = SND_xxx id
//!	\param pos = Sample Position to use 0 to 255
//!	\param rate = The rate
//------------------------------------------------------------------------------
void CMethDoc::PlaySample(int id, int pos, int rate)
{
#ifdef METHANE_MIKMOD
	m_pMikModDrv->PlaySample(id, pos, rate);
#endif
}

//------------------------------------------------------------------------------
//! \brief Stop the module (called from the game)
//------------------------------------------------------------------------------
void CMethDoc::StopModule(void)
{
#ifdef METHANE_MIKMOD
	m_pMikModDrv->StopModule();
#endif
}

//------------------------------------------------------------------------------
//! \brief Play a module (called from the game)
//!
//! 	\param id = SMOD_xxx id
//------------------------------------------------------------------------------
void CMethDoc::PlayModule(int id)
{
#ifdef METHANE_MIKMOD
	m_pMikModDrv->PlayModule(id);
#endif
}

//------------------------------------------------------------------------------
//! \brief Update the current module (ie restart the module if it has stopped) (called from the game)
//!
//! 	\param id = SMOD_xxx id (The module that should be playing)
//------------------------------------------------------------------------------
void CMethDoc::UpdateModule(int id)
{
#ifdef METHANE_MIKMOD
	m_pMikModDrv->UpdateModule(id);
#endif
}

//------------------------------------------------------------------------------
//! \brief Load the high scores
//------------------------------------------------------------------------------
void CMethDoc::LoadScores(void)
{
	FILE *fptr;
	char *mptr;
	char *tptr;
	char let;
	int cnt;

	fptr = fopen(HighScoreFileName, "r");
	if (!fptr) return;	// No scores available
	cnt = sizeof(m_GameControls);
	fread(m_GameControls, sizeof(m_GameControls), 1, fptr);
	fread(m_GameTarget.m_Game.m_PlayerNameBuff1, sizeof(m_GameTarget.m_Game.m_PlayerNameBuff1), 1, fptr);
	m_GameTarget.m_Game.m_PlayerNameBuff1[4] = 0;
	// Allocate file memory, which is cleared to zero
	mptr = (char *) calloc(1, HighScoreLoadBufferSize);
	if (!mptr)		// No memory
	{
		fclose(fptr);
		return;
	}
	fread( mptr, 1, HighScoreLoadBufferSize-2, fptr);	// Get the file

	// (Note: mptr is zero terminated)
	tptr = mptr;
	for (cnt=0; cnt<MAX_HISCORES; cnt++)	// For each highscore
	{

		if (!tptr[0]) break;

		m_GameTarget.m_Game.InsertHiScore( atoi(&tptr[4]), tptr );

		do	// Find next name
		{
			let = *(tptr++);
		}while (!( (let=='$') || (!let) ));
		if (!let) break;	// Unexpected EOF
	}

	free(mptr);

	fclose(fptr);

}

//------------------------------------------------------------------------------
//! \brief Save the high scores
//------------------------------------------------------------------------------
void CMethDoc::SaveScores(void)
{
	FILE *fptr;
	int cnt;
	HISCORES *hs;

	fptr = fopen(HighScoreFileName, "w");
	if (!fptr) return;	// Cannot write scores
	fwrite(m_GameControls, sizeof(m_GameControls), 1, fptr);
	fwrite(m_GameTarget.m_Game.m_PlayerNameBuff1, sizeof(m_GameTarget.m_Game.m_PlayerNameBuff1), 1, fptr);
	for (cnt=0, hs=m_GameTarget.m_Game.m_HiScores; cnt<MAX_HISCORES; cnt++, hs++)
	{
		fprintf(fptr, "%c%c%c%c%d$", hs->name[0], hs->name[1], hs->name[2], hs->name[3], hs->score);
	}
				
	fclose(fptr);

}

//------------------------------------------------------------------------------
//! \brief The Display Options screen
//!
//! 	\param screen_ptr = 32 bit per pixel screen
//!	\param page_no	= Instruction page number
//------------------------------------------------------------------------------
void CMethDoc::DisplayOptions( void *screen_ptr, int page_no )
{
	unsigned char *dptr;
	int cnt;
	char textbuffer[64];
	dptr = (unsigned char *) screen_ptr;
	for(cnt = 0;cnt <FONT32_NUM_COLOURS; cnt++)
		{
		m_GameTarget.m_rgbPalette[cnt].red = SMB_Font32_Palette[cnt]>>8;
		m_GameTarget.m_rgbPalette[cnt].blue = SMB_Font32_Palette[cnt]>>16;
		m_GameTarget.m_rgbPalette[cnt].green =SMB_Font32_Palette[cnt]>>24;
		}
	
	
	// Clear the screen
	for (cnt=0; cnt<(SCR_WIDTH * SCR_HEIGHT); cnt++)
	{
		dptr[cnt] = 0;
	}
	switch(page_no)
		{
		case 0:
			{
			DrawFont32Text( dptr, 1*16, "INSTRUCTIONS:");
			DrawFont32Text( dptr, 3*16, "FIRE TO START");
			//DrawFont32Text( dptr, 4*16, "TYPE PLAYER NAMES");
			DrawFont32Text( dptr, 5*16, "TAP FIRE TO GAS");
			DrawFont32Text( dptr, 7*16, "HOLD FIRE TO SUCK");
			DrawFont32Text( dptr, 9*16, "RELEASE FIRE TO");
			DrawFont32Text( dptr, 10*16, "THROW AT THE WALL");
			}break;
		case 1:
			{
			DrawFont32Text( dptr, 1*16, "PLAYER ONE:");
			DrawFont32Text( dptr, 3*16, "USER DEFINED");
			for(int loop = 0;loop<5;loop++)
				{
				char* bufptr = textbuffer;
				sprintf(textbuffer, "%s : %s",KGameKeys[loop], SDL_GetKeyName(m_GameControls[loop]));
				while(*bufptr != 0)
					{
					*bufptr = toupper(*bufptr);
					bufptr++;
					}
				DrawFont32Text( dptr, (4+loop)*16, textbuffer);
				}
			DrawFont32Text( dptr, 9*16, "OR DEFAULT KEYS");
			DrawFont32Text( dptr, 10*16, "CURSOR KEYS");
			DrawFont32Text( dptr, 11*16, "CTRL OR F5 TO FIRE.");
			/*DrawFont32Text( dptr, 7*16, "PLAYER TWO:");
		DrawFont32Text( dptr, 9*16, "USE A W S D");
		DrawFont32Text( dptr, 10*16, "SHIFT TO FIRE");*/

			}break;
		case 2:
			{
			DrawFont32Text( dptr, 1*16, "OTHER KEYS:");
			sprintf(textbuffer, "PAUSE   :%s", SDL_GetKeyName(m_GameControls[5]));
			char* bufptr = textbuffer;
			while(*bufptr != 0)
				{
				*bufptr = toupper(*bufptr);
				bufptr++;
				}
			DrawFont32Text( dptr, 3*16, textbuffer);
			
			sprintf(textbuffer, "SWAP GFX:%s", SDL_GetKeyName(m_GameControls[6]));
			
			bufptr = textbuffer;
			while(*bufptr != 0)
				{
				*bufptr = toupper(*bufptr);
				bufptr++;
				}
			DrawFont32Text( dptr, 4*16, textbuffer);
			DrawFont32Text( dptr, 5*16, "EXIT : ESC OR 'C'");
			DrawFont32Text( dptr, 13*16, "PRESS FIRE TO START");
			DrawFont32Text( dptr, 14*16, "OTHER TO REDEFINE");
			}break;
		case 3:
			DrawFont32Text( dptr, 1*16, "PRESS KEY FOR :");
			DrawFont32Text( dptr, 3*16, (char*) KGameKeys[key_redefine_index]);
			break;
		}
		
	if(page_no < 2)
		{
		DrawFont32Text( dptr, 14*16, "PRESS ANY KEY");
		}
	DrawScreen( screen_ptr );
}


//------------------------------------------------------------------------------
//! \brief Draw the 32 colour font text (for the options screen)
//!
//! 	\param dptr = 32 bit per pixel screen
//!	\param ypos = Font y pos in pixels
//!	\param tptr = The text
//------------------------------------------------------------------------------
void CMethDoc::DrawFont32Text( unsigned char *dptr, int ypos, char *tptr)
{
	int txtlen;
	int xpos;
	unsigned char *wptr;
	char letter;
	char *fptr;
	int width;
	int height;
	int offset;
	int cnt;
	int *palette;

	txtlen = ::strlen(tptr);
	
	//xpos = (SCR_WIDTH/2) - (txtlen*(16/2));
	xpos = 0;
	ypos = ypos * SCR_WIDTH;

	dptr = dptr + xpos + ypos;
	
	for (; txtlen>0; txtlen--)
	{
		letter = *(tptr++);
		// Validate the letter
		if ( (letter <32) || (letter > (FONT32_NUM_IN_LIST+32)) ) break;
		letter -=32;
		fptr = Spr_Font32[letter];
		if (fptr)	// Valid font
		{
			wptr = dptr;	// Save the pointer

			// Get sizes
			xpos = *(fptr++);
			ypos = *(fptr++);
			width = *(fptr++);
			height = *(fptr++);

			ypos = ypos * SCR_WIDTH;
			wptr = wptr + xpos + ypos;	// To the correct position

			offset = SCR_WIDTH - width;	// Offset to next line on the screen

			// For all rows in the font
			for (; height > 0; height--)
			{
				for (cnt=0; cnt<width; cnt++)
				{
					*(wptr++) = *(fptr++);
					
				}
				wptr+= offset;
			}

		}
		dptr += 16;	// To the next font position
	}

}
